import fs from "fs";
import pdf_converter from "html-pdf";
import path from 'path';
/**
 * This class is responsible for all things pdf creation.
 * This uses the html templates from src/templates.
 */
export class PdfCreator {
    private templateDir = path.join(__dirname, '/templates');

    //TODO: Accept the runner class
    public async generateSponsoringContract(): Promise<Pdf> {
        let template = fs.readFileSync(`${this.templateDir}/sponsoring_contract.html`, 'utf8');
        template = template.replace("{{Runner Name}}", "lelele");
        return new Pdf(await pdf_converter.create(template, { format: "A5", orientation: "landscape" }));
    }

}

export class Pdf {
    content: any;

    constructor(pdf: any) {
        this.content = pdf;
    }

    /**
     * Promise wrapper function that resolves the toBuffer promise for pdf generation.
     */
    public async toBuffer(): Promise<any> {
        let promise = await new Promise((resolve, reject) => {
            this.content.toBuffer(function (err, buffer) {
                resolve(buffer);
            });
        });
        return await promise;
    }

    /**
     * Promise wrapper function that resolves the toStream promise for pdf generation.
     */
    public async toStream(): Promise<any> {
        let promise = await new Promise((resolve, reject) => {
            this.content.toStream(function (err, stream) {
                resolve(stream);
            });
        });
        return await promise;
    }
}